
#include <utility/ostream.h>
#include <utility/string.h>
#include <utility/malloc.h>
#include <utility/output_handler.h>
#include <auth/hmac_sha2.h>

#include <machine.h>
#include <alarm.h>
#include <sensor.h>
#include <utility/string.h>


__USING_SYS

OStream cout;
bool funcionou;

void turn_on_led1() {
   unsigned int *GPIO_BASE = (unsigned int*)0x80000000;
   *GPIO_BASE = 1 << 23;
}

void turn_on_led2() {
    unsigned int *GPIO_BASE = (unsigned int*)0x80000000;
    *GPIO_BASE = 1 << 24;
}

int main()
{
    funcionou = true;	

    static char *messages[] =
    {
        "Hi There",
        "what do ya want for nothing?",
        '\0',
        '\0',
        "Test With Truncation",
        "Test Using Larger Than Block-Size Key - Hash Key First",
        "This is a test using a larger than block-size key "
        "and a larger than block-size data. The key needs"
        " to be hashed before being used by the HMAC algorithm."
    };

    unsigned char mac[SHA512_DIGEST_SIZE];
    unsigned char mac2[SHA512_DIGEST_SIZE];
    unsigned char mac3[SHA512_DIGEST_SIZE];
    unsigned char *keys[7];
    unsigned int keys_len[7] = {20, 4, 20, 25, 20, 131, 131};
    unsigned int messages2and3_len = 50;
    unsigned int mac_256_size;
    int i;

    for (i = 0; i < 7; i++) {
        keys[i] = (unsigned char *) malloc(keys_len[i]);
        if (keys[i] == '\0') {
	    turn_on_led1();
            cout <<  "Can't allocate memory\n";
            return 1;
        }
    }

    memset(keys[0], 0x0b, keys_len[0]);
    strcpy((char *) keys[1], "Jefe");
    memset(keys[2], 0xaa, keys_len[2]);
    for (i = 0; i < (int) keys_len[3]; i++)
        keys[3][i] = (unsigned char) i + 1;
    memset(keys[4], 0x0c, keys_len[4]);
    memset(keys[5], 0xaa, keys_len[5]);
    memset(keys[6], 0xaa, keys_len[6]);

    messages[2] = (char *) malloc(messages2and3_len + 1);
    messages[3] = (char *) malloc(messages2and3_len + 1);

    if (messages[2] == '\0' || messages[3] == '\0') {
	turn_on_led1();
        cout << "Can't allocate memory\n";
        return 1;
    }

    messages[2][messages2and3_len] = '\0';
    messages[3][messages2and3_len] = '\0';

    memset(messages[2], 0xdd, messages2and3_len);
    memset(messages[3], 0xcd, messages2and3_len);

    cout << ("HMAC-SHA-2 IETF Validation tests\n\n");

    for (i = 0; i < 7; i++) {
        if (i != 4) {
            mac_256_size = SHA256_DIGEST_SIZE;
        } else {
           mac_256_size = 128 / 8;
        }

        cout << "Test " << (i + 1) << endl;

        hmac_sha256(keys[i], keys_len[i], (unsigned char *) messages[i],
                    strlen(messages[i]), mac, mac_256_size);
	hmac_sha256(keys[i], keys_len[i], (unsigned char *) messages[i],
                    strlen(messages[i]), mac2, mac_256_size);
	hmac_sha256(keys[i], keys_len[i], (unsigned char *) messages[1],
                    strlen(messages[i]), mac3, mac_256_size);

       if(strcmp((const char*)mac, (const char*)mac2) != 0) funcionou = 0;
       if(i != 1 ) {
		if(strcmp((const char*)mac3, (const char*)mac2) == 0) funcionou = 0;
	}

    }

    if(funcionou)
	turn_on_led2();
    else
	turn_on_led1();

    return 0;

}

