
#include <machine.h>
#include <alarm.h>
#include <sensor.h>
#include <auth/securitymessage.h>
#include <tcp.h>


__USING_SYS

const unsigned char SINK_ID  = 0x01;
const unsigned int DATA_SIZE = 32;
const unsigned int MAC_SIZE = 16;

char msg[DATA_SIZE];
char mac_msg[MAC_SIZE+DATA_SIZE];

long long int acordoDeChaves();

OStream cout;

void turn_on_led1() {
    unsigned int *GPIO_BASE = (unsigned int*)0x80000000;
    *GPIO_BASE = 1 << 23;
}

void sensor(unsigned char id) {

    Alarm::delay(2000000);
    cout << "+++++ Starting sensor " <<  id << "+++++\n";
    turn_on_led1();
    SecurityMessage* sm = new SecurityMessage;
    TCP::Channel  socket;
    socket.bind(1337);

    sm->keyHandShakeSensor(&socket);//primeiro faz o acordo de chaves

    for (unsigned int i = 0; i < DATA_SIZE; i++) {
        msg[i] = i;
    }

    int port = 1337;
    char * address = "10.0.0.110";

    while (true) {
        cout << "Preparado para enviar, esperando 3 segundos" << endl;
        Alarm::delay(3000000);
        char msg[2] = {"A"};
        sm->send(msg, &socket, address, port);//envia as temperaturas
    }
}


int main() {
    IP *ip = IP::instance();
    ip->set_address(IP::Address(10, 0, 0, 110));
    ip->set_gateway(IP::Address(10, 0, 0, 1));
    ip->set_netmask(IP::Address(255, 255, 255, 0));

    sensor(1);
}

/**
O acordo de chaves deve ser feito com a troca de y's entre sensor e servidor.
é chamado o generateKey do SecurityMessage pra isso (mas ainda não está mandando e recebendo y, isso é possível de fazer no EPOS?)
*/


