#ifndef CRYPTOGRAPHY_H
#define CRYPTOGRAPHY_H
#include "auth/message.h"

typedef long long int llint;

class Cryptography
{
private:
    char* sha1(Message msg); //retorna o hash, utilizado na assinatura da msg
    static const int MAC_SIZE = 16;

public:
    Cryptography();
    Message* sign(Message* msg);
    void encrypt(char* data, char* key, char* encrypted, char*mac);
    void decrypt(char* msg, char* key, char* decrypted);
    void concat(char* mac, char* msg);
    void getMacFromMessage(char* mac, char * mac_message);
    bool check_mac(char * decrypted, char* key, char* mac);
    Message* verifySignature(Message* msg);

};

#endif //CRYPTOGRAPHY_H
