
#ifndef SECURITYMESSAGE_H
#define SECURITYMESSAGE_H
#include <machine.h>
#include <utility/ostream.h>
#include <auth/diffiehellman.h>
#include "auth/cryptography.h"
#include <tcp.h>

__USING_SYS
        class SecurityMessage
{
private:
    OStream scout;
    DiffieHellman* df;
    Cryptography * c;
    long long int receiveYb();
    char encrypted[18];
    char decrypted[16];
    char mac[16];
public:
    void sendAck();
    SecurityMessage();
    DiffieHellman* getDiffieHellman();
    //long long int generateKey();
    bool send(char* msg, TCP::Channel* client, char* address, int port);
    char* receive();
    void keyHandShakeSensor(TCP::Channel* socket);
    void keyHandShakeServer(TCP::Channel* socket);

    void getMacFromMessage(char* mac, char* mac_message)
    {
        strncpy(mac, mac_message, 16 );

    }

	long long int getKey();

};

#endif
