#include "auth/diffiehellman.h"
#include <utility/random.h>
#include <arch/arm7/tsc.h>

__USING_SYS

llint DiffieHellman::primo() { return _primo ; }
llint DiffieHellman::raiz_primitiva() { return _raiz_primitiva; }

DiffieHellman::DiffieHellman(){
    _primo = 179426549; //public prime
    _raiz_primitiva = 3;
}

llint DiffieHellman::obterY()
{
    Pseudo_Random::seed(TSC::time_stamp());
    _x = Pseudo_Random::random()%1000;
    llint Ya = modPow(_raiz_primitiva, _x, _primo);
    return Ya;
}

void DiffieHellman::calcularChave(llint  Yb)
{
    _key =  modPow(Yb, _x, _primo);
}

llint DiffieHellman::modPow(llint base, llint exponent, llint modulus) {

            long long int result = 1;

            while (exponent > 0) {
                if ((exponent%2) == 1) {
                    // exponent is odd, multiply base^(exponent-1) by the base to get base^exponent
                    result = (result * base) % modulus;
                    --exponent;
                }
                exponent /= 2;
                base = (base * base) % modulus;
            }

            return result;
}

llint DiffieHellman::getKey() {
    return _key;
}

//FALTA: getKey() e getKey(IP) - no caso de servidor
