#include <auth/persistence.h>

Persistence::Persistence()
{
    _size = 0;
    _free = 0;
    _ip_array = new int[_size];
    _key_array = new llint[_size];
}

bool Persistence::insert(int ip, llint key)
{
    if(getKey(ip) != -1)
        return false;

    if(_free == 0)
    {
        _size++;
        int * _ip_array_temp = new int[_size];
        llint * _key_array_temp = new llint[_size];

        for(int i = 0; i < _size; i++)
        {
            _ip_array_temp[i] = _ip_array[i];
            _key_array_temp[i] = _key_array[i];
        }

        _ip_array = _ip_array_temp;
        _key_array = _key_array_temp;

        _ip_array[_size-1] = ip;
        _key_array[_size-1] = key;
    }
    else
    {
        _size++;
        _ip_array[_size-_free] = ip;
        _key_array[_size-_free] = key;
        _free--;
    }

    return true;
}

bool Persistence::remove(int ip)
{
    if(getKey(ip) == -1)
        return false;

    int index;
    for(int i = 0; i < _size; i++)
        if(_ip_array[i] == ip)
            index = i;

    for(int i = index; i < _size; i++)
    {
        _ip_array[i] = _ip_array[i+1];
        _key_array[i] = _key_array[i+1];
    }

    _ip_array[_size-1] = 0;
    _key_array[_size-1] = 0;
    _size--;
    _free++;
}

llint Persistence::getKey(int ip)
{
    for(int i = 0; i < _size; i++)
        if(_ip_array[i] == ip)
            return _key_array[i];
    return -1;
}

int * Persistence::ip_array()
{
    if(_free == 0)
        return _ip_array;

    int * retorno = new int[_size];
    for(int i = 0; i < _size; i++)
        retorno[i] = _ip_array[i];
    return retorno;
}

int Persistence::size()
{
    return _size;
}
